/*
FILE
	$Id: tresourcefunc.h,v 1.37 2003/12/22 16:27:39 ggw Exp $
	(tAuthorize.cPasswd template set member)
PURPOSE

AUTHOR
	Template and mysqlRAD2 author: (c) 2001,2002,2003 Gary Wallis.
	GPL License applies, see www.fsf.org for details
TODO

	1-.
	IDEA! Create "wizard" for RFC2317 classless in-addr.arpa delegation
	This would generate all the below by just entering the tNameServer group
	from a select box and entering the /CDIR number below would be /26.

	Fix CNAME rule and NS delegation for this best-practices 
	classless in-addr.arpa delegation

	Example

	You have this in zone "28.100.66.in-addr.arpa":

	0-63    NS    ns1.clientisp.net.
	        NS    ns2.clientisp.net. (This is not working completely)
	0       CNAME    0.0-63
	1       CNAME    1.0-63
	...
	63      CNAME    63.0-63

	Your client isp clientisp.net has this in their zone "0-63.28.100.66.in-addr.arpa":

	        NS    ns1.clientisp.net.
	        NS    ns2.clientisp.net.
	
	0       PTR    subnet0.clientisp.net.
	1       PTR    somehost.clientisp.net.
	2       PTR    www.clientisp.net.
	...
	63      PTR    mail.clientisp.net.

	Needs job for arpa zone mod.

	2-.
	CNAME help/checker needs to make sure internal RHS entries exist in the
	zone itself or as higher level zone in of itself...confused yet! lol.

	Should not allow same cName for another CNAME entry!
 
*/

static char cSearch[100]={""};
static char cuNameServerPullDown[256]={""};
static unsigned uSelectNameServer=0;
static unsigned uCIDR=0;
static unsigned uStartBlock=0;
static unsigned uZoneOwner=0;

//Aux drop/pull downs
//static char cClientPullDown[256]={""};
//static unsigned uClient=0;

//Called from tzonefunc.h
void tResourceTableAddRR(unsigned uZoneId);

//tjobfunc.h
int SubmitJob(char *cCommand, unsigned uNameServer, char *cZone,
	unsigned uPriority, unsigned uTime);

static char cZone[100]={""};
static unsigned uAddArpaPTR=0;

int AddPTRResource(unsigned d, char *cDomain, unsigned uZone);

//Extern
int PopulateArpaZone(char *cZone, char *cIPNum, unsigned uHtmlMode,
		unsigned uFromZone);//bind.c
void UpdateSerialNum(unsigned uZone);//tzonefunc.h

void ExtProcesstResourceVars(pentry entries[], int x)
{

	register int i;
	
	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"uAddArpaPTR"))
			uAddArpaPTR=1;	
		else if(!strcmp(entries[i].name,"cSearch"))
			sprintf(cSearch,"%.99s",entries[i].val);
		else if(!strcmp(entries[i].name,"cuNameServerPullDown"))
		{
			sprintf(cuNameServerPullDown,"%.255s",entries[i].val);
			uSelectNameServer=ReadPullDown("tNameServer","cLabel",cuNameServerPullDown);
		}
		else if(!strcmp(entries[i].name,"uCIDR"))
			sscanf(entries[i].val,"%u",&uCIDR);
		else if(!strcmp(entries[i].name,"uStartBlock"))
		{
			sscanf(entries[i].val,"%u",&uStartBlock);
			if(uStartBlock>249) uStartBlock=249;
			else if(uStartBlock<0) uStartBlock=0;
		}
/*
		else if(!strcmp(entries[i].name,"cClientPullDown"))
		{
			strcpy(cClientPullDown,entries[i].val);
			uClient=ReadPullDown("tClient","cLabel",
					cClientPullDown);
		}
*/
	}

}//void ExtProcesstResourceVars(pentry entries[], int x)


void RRCheck(int uMode)
{
	char cRRType[100]={""};
	unsigned a=0,b=0,c=0,d=0;
			
	strcpy(cRRType,ForeignKey("tRRType","cLabel",uRRType));
	strcpy(cZone,ForeignKey("tZone","cZone",uZone));
	
	//For all TODO
	if(!cName[0] && strcmp(cRRType,"NS"))
	{
		mode=uMode;
		tResource("cName is required");
	}


	//TODO
	if(strchr(cName,'.'))
	{
		sprintf(query,"%s.",cZone);
		if(strcmp(query,cName))
		{
			sprintf(query,".%s.",cZone);
			if(!strstr(cName+(strlen(cName)-strlen(query)),query))
			{
				mode=uMode;
				tResource("If cName is fully qualified it must end with cZone and final period.");
			}
		}
	}

	//TODO
	//Make sure only one cName exists with same value per zone...

		
	if(!strcmp(cRRType,"CNAME"))
	{
		//TODO get docs on valid use and default helper use of this RR
		//(cName) LHS should have no dot '.' or end with zone name. This is done for all
		//zone RRs.
		//(cParam1) RHS can be any FQDN. If with trailing dot ok. If not add zone with dot.
		//All cases
		//cParam2 not used. Erased.
		cParam2[0]=0;

		mode=uMode;
		if(!cParam1[0])
		{
				sprintf(cParam1,"%s.",cZone);
tResource("cParam1 is required. Common default entry made for you, check/change.");
		}
		else
		{
			char cParam1Save[101]={""};
			char cParam1Temp[101]={""};

			sprintf(cParam1Save,"%.100s",cParam1);
			//converts, eliminates illegal chars.
			//helpers try to format for you...lol
			FQDomainName(cParam1);

			if(strchr(cParam1,'.'))
			{
				//FQDN
				//Missing trailing dot
				if(cParam1[strlen(cParam1)-1]!='.')
				{
					sprintf(cParam1Temp,"%.100s.",cParam1);
					strcpy(cParam1,cParam1Temp);
				}
				if(strcmp(cParam1,cParam1Save))
					tResource("cParam1 was changed check/fix");
			}
			else
			{
				//Not FQDN, but internal zone member or another zone?

				//TODO
				//Advanced help not implemented yet.
				//Check in this zone for A record. Should not be another CNAME.
				//Check in tZone

				if(cParam1[strlen(cParam1)-1]!='.')
				{
					sprintf(cParam1Temp,"%.49s.%.49s.",cParam1,cZone);
					strcpy(cParam1,cParam1Temp);
				}
				if(strcmp(cParam1,cParam1Save))
					tResource("cParam1 was changed check/fix");
			}

		}
	}
	else if(!strcmp(cRRType,"A"))
	{

		if(!strcmp(cZone+strlen(cZone)-5,".arpa"))
			tResource("Can not add A records to arpa zones");
		sscanf(cParam1,"%u.%u.%u.%u",&a,&b,&c,&d);
		if(a>254) a=0;
		if(b>254) b=0;
		if(c>254) c=0;  
		if(d>254) d=0;  

		sprintf(cParam1,"%u.%u.%u.%u",a,b,c,d);

		cParam2[0]=0;
		if(!a || !d)
		{
			mode=uMode;
			tResource("Invalid IP Number for cParam1");
		}
	}
	else if(!strcmp(cRRType,"PTR"))
	{
		cParam2[0]=0;
		FQDomainName(cParam1);
		if(!cParam1[0])
		{
			mode=uMode;
			tResource("cParam1 is required");
		}
		if(cParam1[strlen(cParam1)-1]!='.') strcat(cParam1,".");
	}
	else if(!strcmp(cRRType,"MX"))
	{
		if(!strcmp(cZone+strlen(cZone)-5,".arpa"))
			tResource("Can not add MX records to arpa zones");
		sscanf(cParam1,"%u",&a);
		sprintf(cParam1,"%u",a);
		if(!a || a>1000)
		{
			mode=uMode;
			tResource("Invalid MX Priority Number for cParam1");
		}
		FQDomainName(cParam2);
		if(!cParam2[0])
		{
			mode=uMode;
			tResource("cParam2 is required");
		}
		if(cParam2[strlen(cParam2)-1]!='.') strcat(cParam2,".");
		
	}
	else if(!strcmp(cRRType,"NS"))
	{
		//All cases
		cParam2[0]=0;
		if(!cParam1[0])
		{
			mode=uMode;
			tResource("cParam1 is required");
		}
		FQDomainName(cParam1);
		if(cParam1[strlen(cParam1)-1]!='.') strcat(cParam1,".");

		if(strcmp(cZone+strlen(cZone)-5,".arpa"))
		{
			sprintf(cName,"%s.",cZone);
		}
		//else no other rules for arpa zone for now TODO
	}
	else if(!strcmp(cRRType,"HINFO"))
	{
		if(!cParam1[0])
		{
			mode=uMode;
			tResource("cParam1 is required");
		}
		if(cParam1[0]!='"' && cParam1[strlen(cParam1)-1]!='"')
		{
			sprintf(query,"\"%s\"",cParam1);
			strcpy(cParam1,query);
		}

		if(!cParam2[0])
		{
			mode=uMode;
			tResource("cParam2 is required");
		}
		if(cParam2[0]!='"' && cParam1[strlen(cParam2)-1]!='"')
		{
			sprintf(query,"\"%s\"",cParam2);
			strcpy(cParam2,query);
		}
	}
	else if(!strcmp(cRRType,"TXT"))
	{
		cParam2[0]=0;
		if(!cParam1[0])
		{
			mode=uMode;
			tResource("cParam1 is required");
		}
		if(cParam1[0]!='"' && cParam1[strlen(cParam1)-1]!='"')
		{
			sprintf(query,"\"%s\"",cParam1);
			strcpy(cParam1,query);
		}

	}
	else if(1)
	{
		mode=uMode;
		tResource("Must select valid uRRType");
	}

}//void RRCheck(int uMode)


void ExttResourceCommands(pentry entries[], int x)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	unsigned uNameServer;
	time_t clock;

	if(!strcmp(function,"tResourceTools"))
	{
		//ModuleFunctionProcess()

		//Default wizard like two step creation and deletion
		if(!strcmp(command,LANG_NB_NEW))
                {
			ProcesstResourceVars(entries,x);
			sscanf(ForeignKey("tZone","uOwner",uZone),"%u",
					&uZoneOwner);
			if(uZoneOwner) GetClientOwner(uZoneOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uZoneOwner)
				|| (uPermLevel>7 && uReseller==uLoginClient)
				|| (uPermLevel>9) )
			{
				strcpy(cZone,ForeignKey("tZone","cZone",uZone));

				if(uZone==0)
					tResource("Must start from valid zone");

				//Check global conditions for new record here
                        	mode=2000;
                        	tResource(LANG_NB_CONFIRMNEW);
			}
                }
		else if(!strcmp(command,LANG_NB_CONFIRMNEW))
                {
			ProcesstResourceVars(entries,x);
			sscanf(ForeignKey("tZone","uOwner",uZone),"%u",
					&uZoneOwner);
			if(uZoneOwner) GetClientOwner(uZoneOwner,&uReseller);

			//Check this out
			if( (uPermLevel>=7 && uLoginClient==uZoneOwner)
				|| (uPermLevel>7 && uReseller==uLoginClient)
				|| (uPermLevel>9 ) )
			{

				//char query[256];
				unsigned uSaveLoginClient=uLoginClient;

				RRCheck(2000);

				if(!uZoneOwner)
				{
					mode=0;
					tResource("uZoneOwner==0 contact admin asap");
				}

				uResource=0;
				uCreatedBy=uLoginClient;
				uOwner=uZoneOwner;
				uModBy=0;//Never modified
				
				if(uAddArpaPTR && uRRType==1)
				{
					char cFQDN[100];
				
					if(cName[strlen(cName)-1]!='.')
						sprintf(cFQDN,"%s.%s.",cName,cZone);
					else
						strcpy(cFQDN,cName);

					uLoginClient=uZoneOwner;//For tJob coolness
					PopulateArpaZone(cFQDN,cParam1,1,uZone);
					uLoginClient=uSaveLoginClient;
				}


				//tZone needs to be updated
				sscanf(ForeignKey("tZone","uNameServer",uZone),"%u",
					&uNameServer);
				time(&clock);
				//cZone set in RRCheck
				uLoginClient=uZoneOwner;//For tJob coolness
				if(SubmitJob("Modify",uNameServer,cZone,0,clock))
					tResource(mysql_error(&mysql));
				uLoginClient=uSaveLoginClient;
				UpdateSerialNum(uZone);
				//debug only
				//sprintf(query,"uClient=%u uZoneOwner=%u uReseller=%u uOwner=%u",
				//	uClient,uZoneOwner,uReseller,uOwner);
				//tResource(query);
				uOwner=uZoneOwner;
				NewtResource(0);
			}
		}
		else if(!strcmp(command,LANG_NB_DELETE))
                {
                        ProcesstResourceVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
                        	mode=2001;
	                        tResource(LANG_NB_CONFIRMDEL);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMDEL))
                {
                        ProcesstResourceVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
                        	mode=5;
				//tZone needs to be updated
				sscanf(ForeignKey("tZone","uNameServer",uZone),"%u",
					&uNameServer);
				time(&clock);
				if(SubmitJob("Modify",
					uNameServer,ForeignKey("tZone","cZone",uZone),0,clock))
				tResource(mysql_error(&mysql));
				UpdateSerialNum(uZone);
                        	DeletetResource();
			}
                }
		else if(!strcmp(command,LANG_NB_MODIFY))
                {
                        ProcesstResourceVars(entries,x);
			strcpy(cZone,ForeignKey("tZone","cZone",uZone));
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
                        	mode=2002;
                        	tResource(LANG_NB_CONFIRMMOD);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMMOD))
                {
                        ProcesstResourceVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				//Check entries here
				RRCheck(2002);
				uModBy=uLoginClient;
				if(uAddArpaPTR && uRRType==1)
				{
					char cFQDN[100];
				
					if(cName[strlen(cName)-1]!='.')
						sprintf(cFQDN,"%s.%s.",cName,cZone);
					else
						strcpy(cFQDN,cName);

					PopulateArpaZone(cFQDN,cParam1,1,uZone);
				}

				//tZone needs to be updated
				sscanf(ForeignKey("tZone","uNameServer",uZone),"%u",
					&uNameServer);
				time(&clock);
				if(SubmitJob("Modify",uNameServer,cZone,0,clock))
					tResource(mysql_error(&mysql));
				UpdateSerialNum(uZone);
                        	ModtResource();
			}
                }
                else if(!strcmp(command,"Delegation Wizard"))
                {
                        ProcesstResourceVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				//TODO	
				
				mode=3001;
			}
		}
                else if(!strcmp(command,"Create Delegation"))
                {
                        ProcesstResourceVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				time_t luClock;
				register unsigned i;
				unsigned uNumIPs=0;
				char cParam1[16]={""};
				char cNameServer[4][100]={"ns1.clientisp.net","ns2.clientisp.net"
								,"",""};
				unsigned uNumNameServers=2;

				//TODO
				mode=3001;
				//Check uZone,uCIDR and uSelectNameServer
				if(!uZone)
					tResource("Undefined uZone!");
				if(uCIDR>29 || uCIDR<24)
					tResource("CIDR must be in range 24 to 29 (256 to 8 IPs)");
				if(!uSelectNameServer)
					tResource("Must select a valid tNameServer.cLabel from select");
				sprintf(query,"SELECT cList FROM tNameServer WHERE uNameServer=%u",
						uSelectNameServer);
				mysql_query(&mysql,query);
				if(mysql_errno(&mysql)) tResource(mysql_error(&mysql));
				res=mysql_store_result(&mysql);
				if(!(field=mysql_fetch_row(res)))
					tResource("tNameServer.cList empty!");

				time(&luClock);
				uNumIPs=2<<(32-uCIDR-1);
				//jic
				if(uNumIPs>256 || uNumIPs<8)
					tResource("uNumIPs must be in range 8 to 256");
				if((uNumIPs+uStartBlock-1)>255)
					tResource("Start/CIDR goes past last octet 255. Please correct CIDR and/or uStartBlock.");


				//Special case 0/24 (Class C)
				if(uNumIPs==256)
				{

					//TODO must fix tzonefunc also...
					strcpy(cZone,ForeignKey("tZone","cZone",uZone));

					for(i=0;i<uNumNameServers;i++)
					{
sprintf(query,"INSERT INTO tResource SET uZone=%u,cName='%.99s',uRRType=2,cParam1='%.99s.',cComment='DelegationWizard created',uOwner=%u,uCreatedDate=%lu",uZone,cZone,cNameServer[i],uLoginClient,luClock);
						mysql_query(&mysql,query);
						if(mysql_errno(&mysql))
							tResource(mysql_error(&mysql));

					}
					mode=0;
					sprintf(query,"<font size=1>Delegation done for tNameServer set: %s and direct classC delegation</font>",ForeignKey("tNameServer","cLabel",uSelectNameServer));
					tResource(query);
				}

				//Loop for each cList line: Add the NS records.
				for(i=0;i<uNumNameServers;i++)
				{
					sprintf(cParam1,"%u-%u",uStartBlock,uNumIPs-1);
sprintf(query,"INSERT INTO tResource SET uZone=%u,cName='%.15s',uRRType=2,cParam1='%.99s.',cComment='DelegationWizard created',uOwner=%u,uCreatedDate=%lu",uZone,cParam1,cNameServer[i],uLoginClient,luClock);
					mysql_query(&mysql,query);
					if(mysql_errno(&mysql))
						tResource(mysql_error(&mysql));
				}
				

				//Loop for all CNAME records
				for(i=0;i<uNumIPs;i++)
				{
					sprintf(cParam1,"%u.%u-%u",
						i+uStartBlock,uStartBlock,uNumIPs-1);
sprintf(query,"INSERT INTO tResource SET uZone=%u,cName='%u',uRRType=5,cParam1='%s',cComment='DelegationWizard created',uOwner=%u,uCreatedDate=%lu",uZone,uStartBlock+i,cParam1,uLoginClient,luClock);
					mysql_query(&mysql,query);
					if(mysql_errno(&mysql))
						tResource(mysql_error(&mysql));
				}

				mode=0;
				sprintf(query,"<font size=1>Delegation done for tNameServer set: %s and for %u IPs. CIDR %u/%u</font>",ForeignKey("tNameServer","cLabel",uSelectNameServer),uNumIPs,uStartBlock,uCIDR);
				tResource(query);
			}
		}
                else if(!strcmp(command,"Delete Delegation"))
                {
                        ProcesstResourceVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				//TODO
sprintf(query,"DELETE FROM tResource WHERE cComment LIKE 'DelegationWizard%%' AND uZone=%u",uZone);
				mysql_query(&mysql,query);
				if(mysql_errno(&mysql))
					tResource(mysql_error(&mysql));
				tResource("Delete delegation done");
			}
		}
                else if(!strcmp(command,"Delete Records"))
                {
                        ProcesstResourceVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=7 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				//TODO
sprintf(query,"DELETE FROM tResource WHERE uZone=%u",uZone);
				mysql_query(&mysql,query);
				if(mysql_errno(&mysql))
					tResource(mysql_error(&mysql));
				tResource("Delete records done");
			}
		}
	}

}//void ExttResourceCommands(pentry entries[], int x)


void ResourceLinks(unsigned uZone)
{
	MYSQL_RES *res;
	MYSQL_ROW field;
	unsigned uArpa=0;

	if(!strcmp(cZone+strlen(cZone)-5,".arpa"))
	{
		sprintf(query,"SELECT cName,uResource,cParam1 FROM tResource WHERE uZone=%u ORDER BY uResource",uZone);
		uArpa=1;
	}
	else
	{
	sprintf(query,"SELECT tResource.cName,tResource.uResource,tRRType.cLabel FROM tResource,tRRType WHERE tResource.uZone=%u AND tResource.uRRType=tRRType.uRRType ORDER BY tResource.cName"
						,uZone);
	}
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) tResource(mysql_error(&mysql));

	res=mysql_store_result(&mysql);

	while((field=mysql_fetch_row(res)))
	{
		if(uArpa)
		printf("<a class=darkLink href=mysqlBind.cgi?function=tResource&uResource=%s&cZone=%s>%s %20.20s</a><br>\n",field[1],cZone,field[0],field[2]);
		else
		printf("<a class=darkLink href=mysqlBind.cgi?function=tResource&uResource=%s>%s %s</a><br>\n",field[1],field[0],field[2]);
	}

}//void ResourceLinks(unsigned uZone)


void ExttResourceButtons(void)
{
	printf("<table width=260 border=0 bgcolor=#9BC1B3 valign=center>\n");
        printf("<tr><td>");

	printf("<font face=Arial,Helvetica>");
	printf("<font size=2>");
	printf("<u>Search Tools</u><br>");
	printf("<input type=text title=\"cName search input. Use %% . and _ for power searching.\" name=cSearch value=\"%s\" maxlength=99 size=20>",cSearch);

	strcpy(cZone,ForeignKey("tZone","cZone",uZone));

	switch(mode)
        {
                case 2000:
			printf("<p><u>Enter required data</u><br>");
                        printf("<font size=1>");
                        printf(LANG_NBB_CONFIRMNEW);
			if(strcmp(cZone+strlen(cZone)-5,".arpa"))
			{
				printf("<font size=2>");
				printf("<br><input title='For some RR types this will add a PTR entry to the correct .arpa zone' type=checkbox name=uAddArpaPTR> RevDNS");
			}
/*
			if(uPermLevel>7)
			{
				printf("<p><u>Create for customer</u><br>");
				tTablePullDownOwner("tClient;cClientPullDown",
					"cLabel","cLabel",uClient);
			}
*/
                break;

                case 2001:
			printf("<p><u>Think twice</u><br>");
                        printf("<font size=1>");
                        printf(LANG_NBB_CONFIRMDEL);
			if(uPermLevel>9)
			printf("<br><input title='Will remove all records for this zone' class=lwarnButton type=submit name=command value='Delete Records'>");
                break;

                case 2002:
			printf("<p><u>Review record data</u><br>");
                        printf("<font size=1>");
                        printf(LANG_NBB_CONFIRMMOD);
			if(uRRType==1 && strcmp(cZone+strlen(cZone)-5,".arpa"))
			{
				printf("<font size=2>");
				printf("<br><input title='For some RR types this will add a PTR entry to the correct .arpa zone' type=checkbox name=uAddArpaPTR> RevDNS");
			}
			else if(!strcmp(cZone+strlen(cZone)-5,".arpa"))
			{
				printf("<font size=2>");
				printf("<p><input title='Will add NS records and the CIDR defined number of CNAME records in n.0-(2^(32-CIDR))-1 style for supplied NS previously defined in tNameServer to this zone' class=largeButton type=submit name=command value='Delegation Wizard'>");
			}

                break;

		case 3001:
		if(uPermLevel>9)
		{
			printf("<p><u>Delegation Wizard</u><br>");
			tTablePullDown("tNameServer;cuNameServerPullDown","cLabel","cLabel",
				uSelectNameServer);
			printf("<br><input title='Enter CIDR block start number (uStartBlock.) Acceptable range 0-248 depends on CIDR below' type=text name=uStartBlock size=8 maxlength=3 value=0>");
			printf("<br><input title='Enter CIDR number (uCIDR.) Ex. 26 for 64 IP block. Range 24-29' type=text name=uCIDR size=8 maxlength=2>");
			printf("<br><input title='Will add NS records -as per select set- and the CIDR defined number of CNAME records in n.0-(2^(32-CIDR))-1 style to this zone' class=largeButton type=submit name=command value='Create Delegation'>");
			printf("<br><input title='Will remove all records that say DelegationWizard in the cComment field for this zone' class=lwarnButton type=submit name=command value='Delete Delegation'>");
		}
		break;

	}
	
	printf("<font size=2>");

	if(uZone)
	{

		printf("<p><u>ZoneNavList</u><br>");
		printf("<a class=darkLink href=mysqlBind.cgi?function=tZone&uZone=%u&cZone=%s>",
			uZone,cZone);
		if(cZone[0])
			printf("%s</a>",cZone);
		else
			printf("Back to Zone</a>");
		printf("<p><u>RRNavList</u><br>");
		ResourceLinks(uZone);
	}

        printf("</td></tr>\n");
        printf("</table>\n");

}//void ExttResourceButtons(void)


void ExttResourceAuxTable(void)
{

}//void ExttResourceAuxTable(void)


void ExttResourceGetHook(entry gentries[], int x)
{
	register int i;

	for(i=0;i<x;i++)
	{
		if(!strcmp(gentries[i].name,"uResource"))
		{
			sscanf(gentries[i].val,"%u",&uResource);
			mode=6;
		}
		else if(!strcmp(gentries[i].name,"cZone"))
		{
			sprintf(cZone,"%.99s",gentries[i].val);
		}
	}
	tResource("");

}//void ExttResourceGetHook(entry gentries[], int x)


void ExttResourceSelect(void)
{
        //Set non search query here for tTableName()
        if(uPermLevel>=9 && uZone)
	{
		if(cSearch[0])
	sprintf(query,"SELECT %s FROM tResource WHERE uZone=%u AND cName LIKE '%s%%' ORDER BY uResource", VAR_LIST_tResource,uZone,cSearch);
		else
	sprintf(query,"SELECT %s FROM tResource WHERE uZone=%u ORDER BY uResource", VAR_LIST_tResource,uZone);
	}
        if(uPermLevel>=9 && !uZone)
	{
		if(cSearch[0])
	sprintf(query,"SELECT %s FROM tResource WHERE cName LIKE '%s%%' ORDER BY uResource", VAR_LIST_tResource,cSearch);
		else
	sprintf(query,"SELECT %s FROM tResource ORDER BY uResource", VAR_LIST_tResource);
	}
	else if(uZone)
	{
		if(cSearch[0])
	sprintf(query,"SELECT %s FROM tResource WHERE uZone=%u AND uOwner=%u AND cName LIKE '%s%%' ORDER BY uResource", VAR_LIST_tResource,uZone,uLoginClient,cSearch);
		else
	sprintf(query,"SELECT %s FROM tResource WHERE uZone=%u AND uOwner=%u ORDER BY uResource", VAR_LIST_tResource,uZone,uLoginClient);
	}
	else if(1)
	{
		if(cSearch[0])
	sprintf(query,"SELECT %s FROM tResource WHERE uOwner=%u AND cName LIKE '%s%%' ORDER BY uResource", VAR_LIST_tResource,uLoginClient,cSearch);
		else
	sprintf(query,"SELECT %s FROM tResource WHERE uOwner=%u ORDER BY uResource", VAR_LIST_tResource,uLoginClient);
	}

}//void ExttResourceSelect(void)


void ExttResourceSelectRow(void)
{
	if(uPermLevel<10)
	{
		if(strcmp(cZone+strlen(cZone)-5,".arpa"))
		{
                	sprintf(query,"SELECT %s FROM tResource,tClient \
                                WHERE tResource.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u)\
                                AND tResource.uResource=%u",
                        		VAR_LIST_tResource,
					uLoginClient,uLoginClient,uResource);
		}
		else
		{
                	sprintf(query,"SELECT %s FROM tResource WHERE uResource=%u",
			VAR_LIST_tResource,uResource);
		}
	}
	else
	{
                sprintf(query,"SELECT %s FROM tResource WHERE uResource=%u",
			VAR_LIST_tResource,uResource);
	}

}//void ExttResourceSelectRow(void)


void ExttResourceListSelect(void)
{
	char cCat[512];

	if(uPermLevel<10)
		sprintf(query,"SELECT %s FROM tResource,tClient \
		WHERE tResource.uOwner=tClient.uClient \
		AND (tClient.uOwner=%u OR tClient.uClient=%u)",
				VAR_LIST_tResource,
				uLoginClient,
				uLoginClient);
	else
                sprintf(query,"SELECT %s FROM tResource",
				VAR_LIST_tResource);

	//Changes here must be reflected below in ExttResourceListFilter()
        if(!strcmp(filter,"uResource"))
        {
                sscanf(command,"%u",&uResource);
		if(uPermLevel<10)
			strcat(query," AND ");
		else
			strcat(query," WHERE ");
		sprintf(cCat,"tResource.uResource=%u \
						ORDER BY uResource",
						uResource);
		strcat(query,cCat);
        }
        else if(!strcmp(filter,"cName"))
        {
		if(uPermLevel<10)
			strcat(query," AND ");
		else
			strcat(query," WHERE ");
		sprintf(cCat,"tResource.cName LIKE '%s' ORDER BY tResource.cName",command);
		strcat(query,cCat);
        }
        else if(!strcmp(filter,"cParam1"))
        {
		if(uPermLevel<10)
			strcat(query," AND ");
		else
			strcat(query," WHERE ");
		sprintf(cCat,"tResource.cParam1 LIKE '%s' ORDER BY tResource.cParam1",command);
		strcat(query,cCat);
        }
        else if(1)
        {
                //None NO FILTER
                strcpy(filter,"None");
		strcat(query," ORDER BY uResource");
        }

}//void ExttResourceListSelect(void)


void ExttResourceListFilter(void)
{
        //Filter
        printf("<td align=right >Select ");
        printf("<select name=filter>");
        if(strcmp(filter,"uResource"))
                printf("<option>uResource</option>");
        else
                printf("<option selected>uResource</option>");
        if(strcmp(filter,"cName"))
                printf("<option>cName</option>");
        else
                printf("<option selected>cName</option>");
        if(strcmp(filter,"cParam1"))
                printf("<option>cParam1</option>");
        else
                printf("<option selected>cParam1</option>");
        if(strcmp(filter,"None"))
                printf("<option>None</option>");
        else
                printf("<option selected>None</option>");
        printf("</select>");

}//void ExttResourceListFilter(void)


void ExttResourceNavBar(void)
{
	if(uZone) sscanf(ForeignKey("tZone","uOwner",uZone),"%u",&uZoneOwner);
	if(uZoneOwner) GetClientOwner(uZoneOwner,&uReseller);

	printf(LANG_NBB_SKIPFIRST);
	printf(LANG_NBB_SKIPBACK);
	printf(LANG_NBB_SEARCH);

	if( (uPermLevel>=7 && uOwner==uZoneOwner)
			|| (uPermLevel>7 && uReseller==uLoginClient)
			|| uPermLevel>9 )
		printf(LANG_NBB_NEW);

	if( (uPermLevel>=7 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_MODIFY);

	if( (uPermLevel>=7 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )
	printf(LANG_NBB_DELETE);

	printf(LANG_NBB_LIST);

	printf(LANG_NBB_SKIPNEXT);
	printf(LANG_NBB_SKIPLAST);

}//void ExttResourceNavBar(void)


void tResourceTableAddRR(unsigned uZoneId)
{
	mode=2000;
	uZone=uZoneId;

	tResource("Add new resource record");

}//void tResourceTableAddRR(unsigned uZoneId)


int AddPTRResource(unsigned d, char *cDomain, unsigned uZoneArg)
{
	unsigned uSaveuResource=uResource;
	char cSavecName[100];
	char cSavecParam1[100];
	char cSavecParam2[100];
	char *cSavecComment=cComment;
	unsigned uSaveuRRType=uRRType;
	unsigned uSaveuTTL=uTTL;
	unsigned uSaveuZone=uZone;

	if(!d || !cDomain[0] || !uZoneArg) return(1);

	strcpy(cSavecName,cName);
	strcpy(cSavecParam1,cParam1);
	strcpy(cSavecParam2,cParam2);

	uResource=0;
	sprintf(cName,"%u",d);
	uRRType=7;//Fix this...
	uTTL=0;
	//Do not set two periods.
	if(cDomain[strlen(cDomain)-1]!='.')
		sprintf(cParam1,"%s.",cDomain);
	else
		sprintf(cParam1,"%s",cDomain);
	cParam2[0]=0;
	cComment="GenerateArpaZones()";//beware!
	uZone=uZoneArg;

	//Only allow one PTR entry per FQDN. Makes sense. ?Right? BUT
	//don't let joe user delete root entries...makes sense?

	//Or delete somebody else's entries, what about conflicts? If PTR conflict don't add
	//have end-user customer/reseller complain to admin.
	if(uPermLevel<10)
	{
		MYSQL_RES *res;

sprintf(query,"SELECT uResource FROM tResource WHERE uRRType=7 AND cName='%s' AND uOwner!=%u",cName,uLoginClient);
		mysql_query(&mysql,query);
		if(mysql_errno(&mysql)) 
			goto ExitPoint;

		res=mysql_store_result(&mysql);
		if(mysql_num_rows(res))
		{
			mysql_free_result(res);
			goto ExitPoint;
		}
		mysql_free_result(res);
	

	}

	sprintf(query,"DELETE FROM tResource WHERE uRRType=7 AND cParam1='%s' AND uOwner=%u",cParam1,uLoginClient);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
		goto ExitPoint;
	
	//Check for other entries, if they exist first come first served
	//(round-robin PTR records actually)
	//notify admin to resolve dispute for rev dns

	uCreatedBy=uLoginClient;
	uOwner=uLoginClient;
	uModBy=0;//Never modified
	Insert_tResource();

ExitPoint:
	uResource=uSaveuResource;
	strcpy(cName,cSavecName);
	uRRType=uSaveuRRType;
	uTTL=uSaveuTTL;
	strcpy(cParam1,cSavecParam1);
	strcpy(cParam2,cSavecParam2);
	cComment=cSavecComment;
	uZone=uSaveuZone;

	if(mysql_errno(&mysql)) 
		return(1);

	return(0);

}//int AddPTRResource(unsigned d, char *cDomain, unsigned uZone)


